namespace NLP {
  const char *LICENCE = 
    "C&C System Licence Agreement\n"
    "\n"
    "This Licence Agreement (the \"Agreement\") is entered, effective this\n"
    "date, by and between the \"Licensor\" (as defined below), and the\n"
    "individual executing this Agreement below as \"Licensee\" (hereinafter,\n"
    "the \"Licensee\").\n"
    "\n"
    "1. Licensor hereby grants Licensee a royalty-free, non-exclusive,\n"
    "non-transferable licence to use the C&C system (herinafter referred to\n"
    "as the \"Licensed Software\") as follows solely for a Non-Commercial\n"
    "Purpose (as defined in paragraph 3 below):\n"
    "\n"
    "    (a) Licensee may prepare derivative works (the \"Derivative Works\")\n"
    "    which are based on or incorporate all or part of the Licensed\n"
    "    Software, including, without limitation, works (the \"Adaptations\")\n"
    "    which\n"
    "\n"
    "        (i) are translations of all or part of the Licensed Software\n"
    "        into different programming languages, or\n"
    "        (ii) are revisions, improvements or corrections to all or part\n"
    "        of the Licensed Software, \n"
    "\n"
    "provided that, Licensee shall treat all Derivative Works as Licensed\n"
    "Software under this Agreement; and\n"
    "\n"
    "    (b) Licensee may make only such copies of the Licensed Software as\n"
    "    are necessary for Licensee's development of the Derivative Works.\n"
    "\n"
    "2. All copies of the Licensed Software and Derivative Works prepared\n"
    "in accordance with paragraph 1 shall retain the copyright notice\n"
    "appearing in the Licensed Software. If the Licensed Software includes\n"
    "computer programs in object code form, Licensee shall not de-compile,\n"
    "reverse engineer or disassemble such programs.\n"
    "\n"
    "3. As used in this Agreement, \"Non-Commercial Purpose\" means use of\n"
    "the Licensed Software and Derivative Works solely for education or\n"
    "research.  \"Non-Commercial Purpose\" excludes, without limitation, any\n"
    "use of the Licensed Software or Derivative Works for, as part of, or\n"
    "in any way in connection with a product (including software) or\n"
    "service which is sold, offered for sale, licensed, leased, loaned or\n"
    "rented.\n"
    "\n"
    "4. Licensee shall acknowledge use of the Licensed Software and\n"
    "Derivative Works in all publications of research based in whole or in\n"
    "part on their use through citation of the following publication:\n"
    "\n"
    "Parsing the WSJ using CCG and Log-Linear Models\n"
    "Stephen Clark and James R. Curran\n"
    "Proceedings of the 42nd Annual Meeting of the Association for\n"
    "Computational Linguistics (ACL-04), pp. 104-111, Barcelona, Spain 2004\n"
    "\n"
    "5. Licensee hereby grants Licensor a non-exclusive, royalty-free, fully\n"
    "paid-up, worldwide, perpetual licence to:\n"
    "\n"
    "    (a) Reproduce, prepare derivative works based on and distribute all\n"
    "    or part of the Derivative Works; and\n"
    "\n"
    "    (b) Make, have made, use, offer to sell, sell, license or import any\n"
    "    products (including software) or services under any intellectual\n"
    "    property rights owned or licensed by Licensee which relate to\n"
    "\n"
    "        (i) all or part of the Derivative Works (including as executed\n"
    "        by a CPU), or\n"
    "        (ii) methods or concepts embodied in, or implemented through\n"
    "        the execution by a CPU of, the Derivative Works. Licensee\n"
    "        shall provide the contact person (or an alternative contact\n"
    "        notified to the Licensee from time to time)\n"
    "\n"
    "	candc@it.usyd.edu.au\n"
    "\n"
    "        with feedback concerning Licensee's Derivative Works and, if\n"
    "        requested, provide such persons with source code copies of\n"
    "        Licensee's Derivative Works.\n"
    "\n"
    "6. This Agreement is personal between Licensor and Licensee. No\n"
    "ownership interest in the Licensed Software (or the copy of which is\n"
    "provided by Licensor pursuant to paragraph 1) is transferred to\n"
    "Licensee. Licensee's interest in the Derivative Works is limited\n"
    "solely to Licensee's additions and the Derivative Works are subject in\n"
    "their entirety to Licensor's intellectual property rights. Licensor\n"
    "may assign or transfer to any company or person, or grant to any\n"
    "company or person a licence or sublicence under, all or part of its\n"
    "interest in any rights to the Licensed Software, this Agreement, or\n"
    "any licence granted to Licensor hereunder. Licensee may not assign or\n"
    "sublicense Licensee's rights hereunder.\n"
    "\n"
    "7. Licensor may terminate this Agreement at any time by sending\n"
    "written notice of termination to Licensee at the address specified\n"
    "below.  Termination shall be effective as provided in the\n"
    "notice. Unless the notice shall provide otherwise, upon termination,\n"
    "Licensee shall destroy all copies of the Licensed Software and\n"
    "Derivative Works. Licensee's obligations under this Agreement,\n"
    "including any rights granted to Licensor pursuant to paragraph 5,\n"
    "shall survive and continue after termination.\n"
    "\n"
    "8. Licensor has no obligation to support or maintain the Licensed\n"
    "Software and grants Licensee this right to use the Licensed Software\n"
    "\"AS IS\". LICENSEE ASSUMES TOTAL RESPONSIBILITY AND RISK FOR LICENSEE'S\n"
    "USE OF THE LICENSED SOFTWARE. LICENSOR DOES NOT MAKE, AND EXPRESSLY\n"
    "DISCLAIMS, ANY EXPRESS OR IMPLIED WARRANTIES, REPRESENTATIONS OR\n"
    "ENDORSEMENTS OF ANY KIND WHATSOEVER, INCLUDING, WITHOUT LIMITATION,\n"
    "THE IMPLIED WARRANTIES OF MERCHANTABILITY, REASONABLE QUALITY OR\n"
    "FITNESS FOR A PARTICULAR PURPOSE, AND THE WARRANTIES OF TITLE OR\n"
    "NON-INFRINGEMENT. IN NO EVENT SHALL LICENSOR BE LIABLE FOR\n"
    "\n"
    "    (a) ANY INCIDENTAL, CONSEQUENTIAL, OR INDIRECT DAMAGES, DAMAGES\n"
    "    FOR LOSS OF PROFITS, BUSINESS INTERRUPTION, LOSS OF PROGRAMS OR\n"
    "    INFORMATION, AND ANY OTHER LOSS OR DAMAGE WHATSOEVER ARISING OUT\n"
    "    OF THE USE OF OR INABILITY TO USE THE SOFTWARE, EVEN IF LICENSOR\n"
    "    OR ANY OF ITS AUTHORIZED REPRESENTATIVES HAS BEEN ADVISED OF THE\n"
    "    POSSIBILITY OF SUCH DAMAGES,\n"
    "\n"
    "    (b) ANY CLAIM ATTRIBUTABLE TO ERRORS, OMISSIONS, OR OTHER\n"
    "    INACCURACIES IN THE SOFTWARE, OR\n"
    "\n"
    "    (c) ANY CLAIM BY ANY THIRD PARTY. \n"
    "\n"
    "9. This Agreement shall be governed by and construed in accordance\n"
    "with the laws of England and the English courts shall have exclusive\n"
    "jurisdiction.\n"
    "\n"
    "LICENSOR\n"
    "University of Edinburgh\n"
    "James R. Curran\n"
    "University of Oxford\n"
    "University of Sydney\n"
  ;
}
